/*************************************************************************/
/* Previous Day Breakout, version 1.2
/* by bodi0, 2010
/*    ,      ,   ( ),  
/*           .
/*************************************************************************/
extern double Lot = 0.01;
 
extern int StopLoss = 25;
extern int TakeProfit = 150;
extern double AccountIncreaseCoefficient = 1.1;//.      
extern bool UseTrailing = true;
extern int TrailingStopLoss = 15;
extern int TrailingStep = 15;
extern int Volatility = 35; //  
extern int MagicNumber = 888;

bool initialized = false;
int MAX_TRAILING_STEP = 15;

int init() {
   double stopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL);
   if (StopLoss < stopLevel) {
      Print("StopLoss   .    .  : ", stopLevel);
      //return(-1);
      StopLoss = stopLevel;
   }
   if (TakeProfit < stopLevel && !UseTrailing) {
      Print("TakeProfit   .    .  : ", stopLevel);
      //return(-1);
      TakeProfit = stopLevel;
   }
   double minLot = MarketInfo(Symbol(), MODE_MINLOT);
   if (Lot < minLot) {
      Print("  -   .    .  : ", minLot);
      //return(-1);
      Lot=minLot;
   }
   double maxLot = MarketInfo(Symbol(), MODE_MAXLOT);
   if (Lot > maxLot) {
      Print("  -   .    .  : ", maxLot);
      //return(-1);
      Lot = maxLot;
   }
   double lotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
   for (double i = minLot; i <= maxLot; i+=lotStep) {
      if (i == Lot) {
         break;
      }
      if (i + lotStep > maxLot) {
         Print("    .    .   : ", lotStep);
         //return(-1);
         lotStep=minLot;
      }
   }
   if (UseTrailing) {
      if (TrailingStopLoss < stopLevel) {
         Print("TrailingStopLoss  -   .    .  : ", stopLevel);
         //return(-1);
         TrailingStopLoss=stopLevel;
      }
      if (TrailingStep < MAX_TRAILING_STEP) {
         Print("TrailingStep  -   .    .  : ", MAX_TRAILING_STEP);
         //return(-1);
         TrailingStep = MAX_TRAILING_STEP;
      }
   }
   initialized = true;
   return(0);
}

int deinit() {
   initialized = false;
   return(0);
}

int start() {
   if (!initialized) {
      //  ,        ,  
      return(0);
   }
   if (DayOfWeek() == 0 || DayOfWeek() == 6) {
      //    
      return(0);
   }
   if (!IsTradeAllowed()) {
      //  -,    
      return(0);
   }
   
   int ticket;
   int q = 0;
 
   double L = iLow(NULL, NULL, 1);
   double H = iHigh(NULL, NULL, 1);
   double C = iClose(NULL, NULL, 0);
   double O = iOpen(NULL, NULL, 0);
   double pC = iClose(Symbol(),PERIOD_H1,0);//        H1 ( )
   
   
   double spred = MarketInfo(Symbol(), MODE_SPREAD) * Point;
   double sl = StopLoss * Point;
   double tp = TakeProfit * Point;
   
   
   
   if (UseTrailing) {
      TrailingPositions(TrailingStopLoss, TrailingStep, MagicNumber);
   }
   
   //  ,   High  Low   
   if  (O >= H || O <= L) {
      Comment("\n   .\n       OP_BUYSTOP  OP_SELLSTOP.\n Open  High  Low   .");
      return (0);
   }
   
   //   
   for (q = 0; q < OrdersTotal(); q++) {
      if (OrderSelect(q, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
         //        
         if (OrderType() == OP_BUYSTOP) {
            return(0);
         } else if (OrderType() == OP_SELLSTOP) {
            return(0);
         }
      }
   }
   
   double stopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL) * Point;
   //
   double FreeDeposit=NormalizeDouble(AccountBalance()-AccountMargin(),Digits);
   //
   double IncrementalStep=NormalizeDouble((FreeDeposit*AccountIncreaseCoefficient/100),Digits);
  //      
   double IncreasedLot = Lot*IncrementalStep;
  
  
  
   if (IncreasedLot>MarketInfo(Symbol(),MODE_MAXLOT)) IncreasedLot=MarketInfo(Symbol(),MODE_MAXLOT);
   if (IncreasedLot<MarketInfo(Symbol(),MODE_MINLOT)) IncreasedLot=MarketInfo(Symbol(),MODE_MINLOT);
   //   ORDER BUY
   if (H - C >= stopLevel && C - L >= stopLevel && O < H) {
      double tpReal = 0;
      if (!UseTrailing) {
      //   ,     
         tpReal = H + tp + spred * 2;
      }
      if (MathAbs(iOpen(Symbol(),0,1)-iClose(Symbol(),0,1))>Volatility*Point && Bid <= pC) {
      
      ticket = OrderSend(Symbol(), OP_BUYSTOP, NormalizeDouble(IncreasedLot,Digits), H + spred * 2, 0, H - sl + spred * 2, tpReal, NULL, MagicNumber, iTime(Symbol(), Period(), 0) + Period() * 60);
      CheckAndPrintError(ticket);}
   } else {
      Comment("\n\n\n\n\n\n\n\n\n    OP_BUYSTOP\n        .");
   }     
  
   //   ORDER SELL
   if (H - C >= stopLevel && C - L >= stopLevel && O > L) {
      tpReal = 0;
      if (!UseTrailing) {
      //   ,     
         tpReal = L - spred - tp;
      }
      if (MathAbs(iOpen(Symbol(),0,1)-iClose(Symbol(),0,1))>Volatility*Point && Ask>=pC) {
      
      ticket = OrderSend(Symbol(), OP_SELLSTOP, NormalizeDouble(IncreasedLot,Digits), L - spred, 0, L - spred + sl, tpReal, NULL, MagicNumber, iTime(Symbol(), Period(), 0) + Period() * 60);
      CheckAndPrintError(ticket);}
   } else {
      Comment("\n\n\n\n\n\n\n\n\n     OP_SELLSTOP\n        .");
   }
   
}
//   
void TrailingPositions(int trailingStopLoss, int trailingStep, int magicNumber) {
   double bid = 0;
   double ask = 0;
   for (int i = 0; i < OrdersTotal(); i++) {
      if (!(OrderSelect(i, SELECT_BY_POS)) || OrderSymbol() != Symbol() || OrderMagicNumber() != magicNumber) {
         continue;
      }
      
      bid = MarketInfo(OrderSymbol(), MODE_BID);
      ask = MarketInfo(OrderSymbol(), MODE_ASK);
      
      if (OrderType() == OP_BUY) {
         if (bid - OrderOpenPrice() > trailingStopLoss * Point) {
            if (OrderStopLoss() < bid - (trailingStopLoss + trailingStopLoss - 1) * Point || OrderStopLoss() == 0) {
               OrderModify(OrderTicket(), OrderOpenPrice(), bid - trailingStopLoss * Point, OrderTakeProfit(), OrderExpiration());
            }
         }
      } else if (OrderType() == OP_SELL) {
         if (OrderOpenPrice() - ask > trailingStopLoss * Point) {
            if (OrderStopLoss() > ask + (trailingStopLoss + trailingStep - 1) * Point || OrderStopLoss() == 0) {
               OrderModify(OrderTicket(), OrderOpenPrice(), ask + trailingStopLoss * Point, OrderTakeProfit(), OrderExpiration());
            }
         }
      }
   }
}
//  
void CheckAndPrintError(int result) {
   if (result < 0) {
      int err = GetLastError();
      Print(">>>>> (", err, ")");
   }
}